Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoTreeSimplifier.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoTreeSimplifier.cpp	(revision 998)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoTreeSimplifier.cpp	(revision 1007)
@@ -634,55 +722,43 @@
 }
 
-//--------------------------------------------------------------------------------------------------------------------------------
-// 
-//--------------------------------------------------------------------------------------------------------------------------------
-//float TreeSimplifier::DiametroEsferaEnvolvente (FILE* fp_simplifica)
-float TreeSimplifier::DiametroEsferaEnvolvente()
+float TreeSimplifier::BoundingSphereDiameter(void) const
 {
 	float xmax, xmin, ymax, ymin, zmax, zmin;
-	float diametro, cx, cy, cz;
+	float diameter, cx, cy, cz;
 	int j;
 
-	//	2006-02-21.
-	float			percent;
-	long	int	update;
-
-	//inicializo al primero de los vértices de las hojas
-
-	xmax = Vertex[Hojasa[0].Vert_Hoja[0]][0];
+	// initialize all vertices to the first
+	xmax = Vertex[Leaves[0].Vert_Hoja[0]][0];
 	xmin = xmax;
 
-	ymax = Vertex[Hojasa[0].Vert_Hoja[0]][1];
+	ymax = Vertex[Leaves[0].Vert_Hoja[0]][1];
 	ymin = ymax;
 
-	zmax = Vertex[Hojasa[0].Vert_Hoja[0]][2];
+	zmax = Vertex[Leaves[0].Vert_Hoja[0]][2];
 	zmin = zmax;
 
-	// ahora busco los maximos y los minimos correspondientes
-
-
-	//	2006-02-21
-	update	=	counth / 20;
-	percent	=	0.5;
-	for (int i = 1; i < counth; i++)
-	{
-		//	2006-02-21
-		if (mUPB	&&	((i % update) == 0))
-		{
-			mUPB(percent);
-		}
+	// search for max and mins
+
+	int update_each	= countLeaves / 5;
+	for (int i = 1; i < countLeaves; i++)
+	{
+		static int ticks_since_last_update = 0;
+		if (mUPB && ticks_since_last_update>=update_each)
+		{
+			ticks_since_last_update=0;
+			mUPB(1);
+		}
+		ticks_since_last_update++;
 		
-		for ( j=0;j<4;j++)
-		{
+		for (j=0;j<4;j++)
+		{			
+			if ( xmax < Vertex[Leaves[i].Vert_Hoja[j]][0]) xmax = Vertex[Leaves[i].Vert_Hoja[j]][0];
+			if ( xmin > Vertex[Leaves[i].Vert_Hoja[j]][0]) xmin = Vertex[Leaves[i].Vert_Hoja[j]][0];
+
+			if ( ymax < Vertex[Leaves[i].Vert_Hoja[j]][1]) ymax = Vertex[Leaves[i].Vert_Hoja[j]][1];
+			if ( ymin > Vertex[Leaves[i].Vert_Hoja[j]][1]) ymin = Vertex[Leaves[i].Vert_Hoja[j]][1];
 			
-		if ( xmax < Vertex[Hojasa[i].Vert_Hoja[j]][0]) xmax = Vertex[Hojasa[i].Vert_Hoja[j]][0];
-		if ( xmin > Vertex[Hojasa[i].Vert_Hoja[j]][0]) xmin = Vertex[Hojasa[i].Vert_Hoja[j]][0];
-
-		if ( ymax < Vertex[Hojasa[i].Vert_Hoja[j]][1]) ymax = Vertex[Hojasa[i].Vert_Hoja[j]][1];
-		if ( ymin > Vertex[Hojasa[i].Vert_Hoja[j]][1]) ymin = Vertex[Hojasa[i].Vert_Hoja[j]][1];
-		
-		if ( zmax < Vertex[Hojasa[i].Vert_Hoja[j]][2]) zmax = Vertex[Hojasa[i].Vert_Hoja[j]][2];
-		if ( zmin > Vertex[Hojasa[i].Vert_Hoja[j]][2]) zmin = Vertex[Hojasa[i].Vert_Hoja[j]][2];
-
+			if ( zmax < Vertex[Leaves[i].Vert_Hoja[j]][2]) zmax = Vertex[Leaves[i].Vert_Hoja[j]][2];
+			if ( zmin > Vertex[Leaves[i].Vert_Hoja[j]][2]) zmin = Vertex[Leaves[i].Vert_Hoja[j]][2];
 		}
 	}
@@ -692,24 +768,22 @@
 	cz = (zmax + zmin)/2;
 
-
-	diametro = ((xmax-xmin)*(xmax-xmin)) + ((ymax-ymin)*(ymax-ymin)) + ((zmax-zmin)*(zmax-zmin));
-
-return (diametro);
-}
-
-//--------------------------------------------------------------------------------------------------------------------------------
-//  normaliza las distancia
-//--------------------------------------------------------------------------------------------------------------------------------
-void TreeSimplifier::NormalizaDistancia (float diametro)
+	diameter = ((xmax-xmin)*(xmax-xmin)) + ((ymax-ymin)*(ymax-ymin)) + ((zmax-zmin)*(zmax-zmin));
+
+	return (diameter);
+}
+
+void TreeSimplifier::NormalizeDistance(float diameter)
 {
 	float dtmp;
-	for (int i=0; i<counth;i++)
-	{
-		dtmp = Hojasa[i].dist;
-		Hojasa[i].dist = dtmp / diametro;
+	for (int i=0; i<countLeaves;i++)
+	{
+		dtmp = Leaves[i].dist;
+		Leaves[i].dist = dtmp / diameter;
 		
 	}
 }
-
+/*
+
+	THIS FUNCTION IS OBSOLETE, AND NEEDS TO BE ERASED
 //--------------------------------------------------------------------------------------------------------------------------------
 //  establece el criterio como (K1 * dist + K2 * cop)/ K1+K2
@@ -721,28 +795,17 @@
 	int i, j, nhojasi, nhojasj;
 
-	//	2006-02-21
-	float			percent;
-	long	int	update;
-	
-	update	=	counth / 30;
-	percent	=	1;
-	
-	for ( i=0; i<counth;i++)
-	{
-		//	2005-02-21
-		if (mUPB	&&	((i % update) == 0))
-		{
-			mUPB(percent);
-		}
-		
-		if (Hojasa[i].existe == true)
+	int update_each	= countLeaves / 30;
+	
+	for ( i=0; i<countLeaves;i++)
+	{
+		if (Leaves[i].existe == true)
 		{
 			//incializo criterio a un numero elevado
-			Hojasa[i].criterio = 1000;
-			nhojasi = int(Hojasa[i].Cuantas_hojas);
+			Leaves[i].criterio = 1000;
+			nhojasi = int(Leaves[i].Cuantas_hojas);
 			//coplanaridad
-			for ( j =0; j<counth;j++)
+			for ( j =0; j<countLeaves;j++)
 			{
-				if (( j != i) && ( Hojasa[j].existe == true)) // si la hoja aun existe
+				if (( j != i) && ( Leaves[j].existe == true)) // si la hoja aun existe
 				{
 					//17/09/01 ANTES DE CALCULAR NADA, COMPRUEBO QUE ESTAS DOS HOJAS 
@@ -750,21 +813,21 @@
 					// ES COMO MÁXIMO 1
 
-					nhojasj = int(Hojasa[j].Cuantas_hojas);
+					nhojasj = int(Leaves[j].Cuantas_hojas);
 
 					if ( abs((nhojasi - nhojasj)) < 2)
 					{
 						//coplanaridad y lo invierto
-						coptmp2 = Hojasa[i].Coplanaridad(Hojasa[j]); 
+						coptmp2 = Leaves[i].Coplanaridad(Leaves[j]); 
 						coptmp = 1 - coptmp2;
 						//distancia y la normalizo
-						distmp2 = Hausdorff( Hojasa[i], Hojasa[j]); 
+						distmp2 = Hausdorff( Leaves[i], Leaves[j]); 
 						distmp = distmp2 / diametro;
 						// calculo el criterio para esa hoja
 						criteriotmp = (( K1 * distmp * distmp ) + (K2 * coptmp * distmp))/ (K1 + K2);
 						//selecciono el criterio menor
-						if (Hojasa[i].criterio > criteriotmp) 
+						if (Leaves[i].criterio > criteriotmp) 
 						{
-							Hojasa[i].criterio = criteriotmp;
-							Hojasa[i].hoja_crit = j;
+							Leaves[i].criterio = criteriotmp;
+							Leaves[i].hoja_crit = j;
 						}
 					}
@@ -787,18 +850,18 @@
 	//ESTAN EN tres PROCEDIMIENTOS: COLAPSA, ESTABLECECRITERIO Y ESTABLECECRITERIO2
 	
-	for (i = 0; i < counth; i++)
-	{
-		if ((Hojasa[i].existe == true) && (i != hojanueva))
+	for (i = 0; i < countLeaves; i++)
+	{
+		if ((Leaves[i].existe == true) && (i != hojanueva))
 		{	
-			nhojasi = int(Hojasa[i].Cuantas_hojas);
+			nhojasi = int(Leaves[i].Cuantas_hojas);
 			//¿ SE HA DESACTIVADO LA HOJA_CRIT QUE GUARDABA LA HOJA?
-			if ( Hojasa[Hojasa[i].hoja_crit].existe == false)
+			if ( Leaves[Leaves[i].hoja_crit].existe == false)
 			{
-				Hojasa[i].criterio = 1000;
+				Leaves[i].criterio = 1000;
 
 				//coplanaridad
-				for ( j =0; j<counth;j++)
+				for ( j =0; j<countLeaves;j++)
 				{
-					if (( j != i) && ( Hojasa[j].existe == true)) // si la hoja aun existe
+					if (( j != i) && ( Leaves[j].existe == true)) // si la hoja aun existe
 					{
 						//17/09/01 ANTES DE CALCULAR NADA, COMPRUEBO QUE ESTAS DOS HOJAS 
@@ -806,5 +869,5 @@
 						// ES COMO MÁXIMO 1
 
-						nhojasj = int(Hojasa[j].Cuantas_hojas);
+						nhojasj = int(Leaves[j].Cuantas_hojas);
 
 						if ( abs((nhojasi - nhojasj)) < 2)
@@ -812,17 +875,17 @@
 
 							//coplanaridad y lo invierto
-							coptmp2 = Hojasa[i].Coplanaridad(Hojasa[j]); 
+							coptmp2 = Leaves[i].Coplanaridad(Leaves[j]); 
 							coptmp = 1 - coptmp2;	
 							//distancia y la normalizo	
-						//	distmp2 = Hojasa[i].Distancia(Hojasa[j]); 
-							distmp2 = Hausdorff( Hojasa[i],  Hojasa[j]); 
+						//	distmp2 = Leaves[i].Distancia(Leaves[j]); 
+							distmp2 = Hausdorff( Leaves[i],  Leaves[j]); 
 							distmp = distmp2 / diametro;
 							// calculo el criterio para esa hoja
 							criteriotmp = (( K1 * distmp * distmp ) + (K2 * coptmp * distmp))/ (K1 + K2);
 							//selecciono el criterio menor
-							if (Hojasa[i].criterio > criteriotmp) 
+							if (Leaves[i].criterio > criteriotmp) 
 							{
-								Hojasa[i].criterio = criteriotmp;
-								Hojasa[i].hoja_crit = j;
+								Leaves[i].criterio = criteriotmp;
+								Leaves[i].hoja_crit = j;
 							}
 						}
@@ -832,22 +895,22 @@
 			else
 			{ // CALCULARE SI EL CRITERIO CON ESTA HOJA ES MENOR QUE EL ANTERIOR
-				nhojasj = int(Hojasa[hojanueva].Cuantas_hojas);
+				nhojasj = int(Leaves[hojanueva].Cuantas_hojas);
 
 				if ( abs((nhojasi - nhojasj)) < 2)
 				{
 					//coplanaridad y lo invierto
-					coptmp2 = Hojasa[i].Coplanaridad(Hojasa[hojanueva]); 
+					coptmp2 = Leaves[i].Coplanaridad(Leaves[hojanueva]); 
 					coptmp = 1 - coptmp2;
 					//distancia y la normalizo
-					//distmp2 = Hojasa[i].Distancia(Hojasa[hojanueva]); 
-					distmp2 = Hausdorff( Hojasa[i], Hojasa[hojanueva]); 
+					//distmp2 = Leaves[i].Distancia(Leaves[hojanueva]); 
+					distmp2 = Hausdorff( Leaves[i], Leaves[hojanueva]); 
 					distmp = distmp2 / diametro;
 					// calculo el criterio para esa hoja
 					criteriotmp = (( K1 * distmp * distmp ) + (K2 * coptmp * distmp))/ (K1 + K2);
 					//selecciono el criterio menor
-					if (Hojasa[i].criterio > criteriotmp) 
+					if (Leaves[i].criterio > criteriotmp) 
 					{	
-						Hojasa[i].criterio = criteriotmp;
-						Hojasa[i].hoja_crit = hojanueva;
+						Leaves[i].criterio = criteriotmp;
+						Leaves[i].hoja_crit = hojanueva;
 					}
 				}
@@ -855,214 +918,208 @@
 		}
 	}
-}
-//--------------------------------------------------------------------------------------------------------------------------------
-// DEVUELVE LA HOJA QUE TIENE EL NUMERO EN EL CAMPO CRITERIO MENOR
-//--------------------------------------------------------------------------------------------------------------------------------
-
-long int TreeSimplifier::MinimoCriterio (void)
-{
-	float mincrit =0;
-	long int cual=-1;
-	int i=0;
-	
-	//inicializo
-	while (Hojasa[i].existe != true) i++;
-	mincrit = Hojasa[i].criterio;
-	cual =i;
-	//busco la minima
-	for ( i=0;i<counth;i++)
-
-	{
-		if (Hojasa[i].existe == true)
-		{
-			if ( mincrit> Hojasa[i].criterio)
+}*/
+
+
+
+// Gets the laf with the minimum criteria
+long int TreeSimplifier::MinCriteria (void)
+{
+	float mincrit=0.0f;
+	long int which=-1;
+		
+/*	while (Leaves[i].existe != true) i++;
+	mincrit = Leaves[i].criterio;
+	which =i;
+	*/
+	for (int i=0;i<countLeaves;i++)
+	{
+		if (Leaves[i].existe)
+		{
+			if (mincrit>Leaves[i].criterio || which==-1)
 			{
-				mincrit = Hojasa[i].criterio;
-				cual = i;
+				mincrit = Leaves[i].criterio;
+				which = i;
 			}
 		}
 		
 	}
-	return (cual);
-}
-
-
-//--------------------------------------------------------------------------------------------------------------------------------
-// 
-//--------------------------------------------------------------------------------------------------------------------------------
-void TreeSimplifier::ElijeVertices(Hoja& Hoja1, Hoja& Hoja2, long int count)
-{
-	// criterio es el de los dos vertices más alejados del centro de la otra hoja
-	
+	return which;
+}
+
+
+void TreeSimplifier::ChooseVertices(Hoja& leaf1, Hoja& leaf2, long int count)
+{
 	float a,b,c;
 	float dist[4];
 	int indices[4];
 	
-	// primero de la primera hoja cojo los dos primeros vertices
-
-
-	a = Vertex[Hoja1.Vert_Hoja[0]][0];
-	b = Vertex[Hoja1.Vert_Hoja[0]][1];
-	c = Vertex[Hoja1.Vert_Hoja[0]][2];
-
-	dist[0] = ((Hoja2.Centro[0]-a)*(Hoja2.Centro[0]-a)) + ((Hoja2.Centro[1]-b)*(Hoja2.Centro[1]-b)) +
-		   ((Hoja2.Centro[2]-c)*(Hoja2.Centro[2]-c));
-
-	
-	a = Vertex[Hoja1.Vert_Hoja[1]][0];
-	b = Vertex[Hoja1.Vert_Hoja[1]][1];
-	c = Vertex[Hoja1.Vert_Hoja[1]][2];
-
-	dist[1] = ((Hoja2.Centro[0]-a)*(Hoja2.Centro[0]-a)) + ((Hoja2.Centro[1]-b)*(Hoja2.Centro[1]-b)) +
-		   ((Hoja2.Centro[2]-c)*(Hoja2.Centro[2]-c));
-
-	a = Vertex[Hoja1.Vert_Hoja[2]][0];
-	b = Vertex[Hoja1.Vert_Hoja[2]][1];
-	c = Vertex[Hoja1.Vert_Hoja[2]][2];
-
-	dist[2] = ((Hoja2.Centro[0]-a)*(Hoja2.Centro[0]-a)) + ((Hoja2.Centro[1]-b)*(Hoja2.Centro[1]-b)) +
-		   ((Hoja2.Centro[2]-c)*(Hoja2.Centro[2]-c));
-
-
-	a = Vertex[Hoja1.Vert_Hoja[3]][0];
-	b = Vertex[Hoja1.Vert_Hoja[3]][1];
-	c = Vertex[Hoja1.Vert_Hoja[3]][2];
-
-	dist[3] = ((Hoja2.Centro[0]-a)*(Hoja2.Centro[0]-a)) + ((Hoja2.Centro[1]-b)*(Hoja2.Centro[1]-b)) +
-		   ((Hoja2.Centro[2]-c)*(Hoja2.Centro[2]-c));
+	a = Vertex[leaf1.Vert_Hoja[0]][0];
+	b = Vertex[leaf1.Vert_Hoja[0]][1];
+	c = Vertex[leaf1.Vert_Hoja[0]][2];
+
+	dist[0] = ((leaf2.Centro[0]-a)*(leaf2.Centro[0]-a)) + ((leaf2.Centro[1]-b)*(leaf2.Centro[1]-b)) +
+		   ((leaf2.Centro[2]-c)*(leaf2.Centro[2]-c));
+
+	
+	a = Vertex[leaf1.Vert_Hoja[1]][0];
+	b = Vertex[leaf1.Vert_Hoja[1]][1];
+	c = Vertex[leaf1.Vert_Hoja[1]][2];
+
+	dist[1] = ((leaf2.Centro[0]-a)*(leaf2.Centro[0]-a)) + ((leaf2.Centro[1]-b)*(leaf2.Centro[1]-b)) +
+		   ((leaf2.Centro[2]-c)*(leaf2.Centro[2]-c));
+
+	a = Vertex[leaf1.Vert_Hoja[2]][0];
+	b = Vertex[leaf1.Vert_Hoja[2]][1];
+	c = Vertex[leaf1.Vert_Hoja[2]][2];
+
+	dist[2] = ((leaf2.Centro[0]-a)*(leaf2.Centro[0]-a)) + ((leaf2.Centro[1]-b)*(leaf2.Centro[1]-b)) +
+		   ((leaf2.Centro[2]-c)*(leaf2.Centro[2]-c));
+
+
+	a = Vertex[leaf1.Vert_Hoja[3]][0];
+	b = Vertex[leaf1.Vert_Hoja[3]][1];
+	c = Vertex[leaf1.Vert_Hoja[3]][2];
+
+	dist[3] = ((leaf2.Centro[0]-a)*(leaf2.Centro[0]-a)) + ((leaf2.Centro[1]-b)*(leaf2.Centro[1]-b)) +
+		   ((leaf2.Centro[2]-c)*(leaf2.Centro[2]-c));
 
 	for ( int i=0;i<4;i++) indices[i]=i;
 
-	DosMayores(dist, indices);
-	
-	Hojasa[counth].Vert_Hoja[0] = Hoja1.Vert_Hoja[indices[0]]; 
-	Hojasa[counth].Vert_Hoja[1] = Hoja1.Vert_Hoja[indices[1]]; 
-	
-	// segunda hoja los dos ultimos vertices
-
-	
-	a = Vertex[Hoja2.Vert_Hoja[0]][0];
-	b = Vertex[Hoja2.Vert_Hoja[0]][1];
-	c = Vertex[Hoja2.Vert_Hoja[0]][2];
-
-	dist[0] = ((Hoja1.Centro[0]-a)*(Hoja1.Centro[0]-a)) + ((Hoja1.Centro[1]-b)*(Hoja1.Centro[1]-b)) +
-		   ((Hoja1.Centro[2]-c)*(Hoja1.Centro[2]-c));
-
-	
-	a = Vertex[Hoja2.Vert_Hoja[1]][0];
-	b = Vertex[Hoja2.Vert_Hoja[1]][1];
-	c = Vertex[Hoja2.Vert_Hoja[1]][2];
-
-	dist[1] = ((Hoja2.Centro[0]-a)*(Hoja2.Centro[0]-a)) + ((Hoja1.Centro[1]-b)*(Hoja1.Centro[1]-b)) +
-		   ((Hoja2.Centro[2]-c)*(Hoja2.Centro[2]-c));
-
-	a = Vertex[Hoja2.Vert_Hoja[2]][0];
-	b = Vertex[Hoja2.Vert_Hoja[2]][1];
-	c = Vertex[Hoja2.Vert_Hoja[2]][2];
-
-	dist[2] = ((Hoja1.Centro[0]-a)*(Hoja1.Centro[0]-a)) + ((Hoja1.Centro[1]-b)*(Hoja1.Centro[1]-b)) +
-		   ((Hoja1.Centro[2]-c)*(Hoja1.Centro[2]-c));
-
-
-	a = Vertex[Hoja2.Vert_Hoja[3]][0];
-	b = Vertex[Hoja2.Vert_Hoja[3]][1];
-	c = Vertex[Hoja2.Vert_Hoja[3]][2];
-
-	dist[3] = ((Hoja1.Centro[0]-a)*(Hoja1.Centro[0]-a)) + ((Hoja1.Centro[1]-b)*(Hoja1.Centro[1]-b)) +
-		   ((Hoja1.Centro[2]-c)*(Hoja1.Centro[2]-c));
+	TwoGreater(dist, indices);
+	
+	Leaves[countLeaves].Vert_Hoja[0] = leaf1.Vert_Hoja[indices[0]]; 
+	Leaves[countLeaves].Vert_Hoja[1] = leaf1.Vert_Hoja[indices[1]]; 
+	
+
+	
+	a = Vertex[leaf2.Vert_Hoja[0]][0];
+	b = Vertex[leaf2.Vert_Hoja[0]][1];
+	c = Vertex[leaf2.Vert_Hoja[0]][2];
+
+	dist[0] = ((leaf1.Centro[0]-a)*(leaf1.Centro[0]-a)) + ((leaf1.Centro[1]-b)*(leaf1.Centro[1]-b)) +
+		   ((leaf1.Centro[2]-c)*(leaf1.Centro[2]-c));
+
+	
+	a = Vertex[leaf2.Vert_Hoja[1]][0];
+	b = Vertex[leaf2.Vert_Hoja[1]][1];
+	c = Vertex[leaf2.Vert_Hoja[1]][2];
+
+	dist[1] = ((leaf2.Centro[0]-a)*(leaf2.Centro[0]-a)) + ((leaf1.Centro[1]-b)*(leaf1.Centro[1]-b)) +
+		   ((leaf2.Centro[2]-c)*(leaf2.Centro[2]-c));
+
+	a = Vertex[leaf2.Vert_Hoja[2]][0];
+	b = Vertex[leaf2.Vert_Hoja[2]][1];
+	c = Vertex[leaf2.Vert_Hoja[2]][2];
+
+	dist[2] = ((leaf1.Centro[0]-a)*(leaf1.Centro[0]-a)) + ((leaf1.Centro[1]-b)*(leaf1.Centro[1]-b)) +
+		   ((leaf1.Centro[2]-c)*(leaf1.Centro[2]-c));
+
+
+	a = Vertex[leaf2.Vert_Hoja[3]][0];
+	b = Vertex[leaf2.Vert_Hoja[3]][1];
+	c = Vertex[leaf2.Vert_Hoja[3]][2];
+
+	dist[3] = ((leaf1.Centro[0]-a)*(leaf1.Centro[0]-a)) + ((leaf1.Centro[1]-b)*(leaf1.Centro[1]-b)) +
+		   ((leaf1.Centro[2]-c)*(leaf1.Centro[2]-c));
 
 	for ( int i=0;i<4;i++) indices[i]=i;
 
-	DosMayores(dist, indices);
-	
-	Hojasa[counth].Vert_Hoja[2] = Hoja2.Vert_Hoja[indices[0]]; 
-	Hojasa[counth].Vert_Hoja[3] = Hoja2.Vert_Hoja[indices[1]]; 
-
-
-
-	
-}
-
-//--------------------------------------------------------------------------------------------------------------------------------
-// AÑADE HOJAS 
-//--------------------------------------------------------------------------------------------------------------------------------
-//long int TreeSimplifier::Colapsa (Geometry::TreeSimplificationSequence *tss, float diametro)
-long int TreeSimplifier::Colapsa(float diametro)
-{
-	long int i=0, cual=-1;
-	long int otra = -1;
-	float coptmp, coptmp2, distmp, distmp2, criteriotmp;
-//	char linea[250];
-
-//	cual=MinimaDistancia();
-	cual=MinimoCriterio();
-//	otra = Hojasa[cual].hoja_cerca; //para la distancia
-//	otra = Hojasa[cual].hoja_cop;
-	otra = Hojasa[cual].hoja_crit;
+	TwoGreater(dist, indices);
+	
+	Leaves[countLeaves].Vert_Hoja[2] = leaf2.Vert_Hoja[indices[0]]; 
+	Leaves[countLeaves].Vert_Hoja[3] = leaf2.Vert_Hoja[indices[1]]; 
+
+
+
+	
+}
+
+// Add leaves
+long int TreeSimplifier::Collapse(float diam)
+{
+	long int i=0, which=-1;
+	long int other = -1;
+	float coptmp, coptmp2, distmp, distmp2, criteriatmp;
+
+	which=MinCriteria();
+	other = Leaves[which].hoja_crit;
 
 	//desactivo las hojas cercanas
-	Hojasa[cual].existe = false;
-	Hojasa[otra].existe = false;
+	Leaves[which].existe = false;
+	Leaves[other].existe = false;
 	//creo la hoja nueva
 
-	Hojasa[counth].hoja_cerca = -1;
-	Hojasa[counth].dist = 0;
-	Hojasa[counth].hoja_cop = -1;
-	Hojasa[counth].coplanar = 0;
-
-	Hojasa[counth].Cuantas_hojas = Hojasa[cual].Cuantas_hojas + Hojasa[otra].Cuantas_hojas;
-	ElijeVertices(Hojasa[cual], Hojasa[otra], counth);
-	Centroh (Hojasa[counth]);
-	GetNormal ( Hojasa[counth]);
-
-	//18/09/01 
-	if (Hojasa[counth].Cuantas_hojas > 60 )
-	{
-			Hojasa[counth].existe = false;
-			activas--;
+	Leaves[countLeaves].hoja_cerca = -1;
+	Leaves[countLeaves].dist = 0;
+	Leaves[countLeaves].hoja_cop = -1;
+	Leaves[countLeaves].coplanar = 0;
+
+	Leaves[countLeaves].Cuantas_hojas = Leaves[which].Cuantas_hojas + Leaves[other].Cuantas_hojas;
+//	Leaves[countLeaves].Cuantas_hojas = 10;
+	ChooseVertices(Leaves[which], Leaves[other], countLeaves);
+	CalculateLeafCenter (Leaves[countLeaves]);
+	CalculateLeafNormal (Leaves[countLeaves]);
+
+	// find out the minimal octree node that can contain this leaf
+	LeafOctree *onode = GetMinOctreeNodeForLeaf(octree,Leaves[countLeaves]);
+	octree_owning_leaf[countLeaves] = onode;
+	onode->leaves.push_back(countLeaves);
+
+/*	if (Leaves[countLeaves].Cuantas_hojas > 60 )
+	{
+			Leaves[countLeaves].existe = false;
+			activeLeaves--;
 	}
 	else
-	{
-		//establezco el criterio para la hoja nueva
-     	Hojasa[counth].existe = true;
-		Hojasa[counth].criterio = 1000;
-		Hojasa[counth].id_triangulo[0] = counth*2;
-		Hojasa[counth].id_triangulo[1] = counth*2+1;
-
- 		//coplanaridad
-		for (int j = 0; j < (counth+1); j++)
-		{
-			if (( j != counth) && ( Hojasa[j].existe == true)) // si la hoja aun existe
+	{		*/
+     	Leaves[countLeaves].existe = true;
+		Leaves[countLeaves].criterio = 1000000.0f;
+		Leaves[countLeaves].id_triangulo[0] = countLeaves*2;
+		Leaves[countLeaves].id_triangulo[1] = countLeaves*2+1;
+
+ 		float area_leaf_i = CalculateLeafArea(Leaves[i])/diam;
+
+		for (int j = 0; j < (countLeaves+1); j++){
+/*		int visit_parents = VISIT_PARENTS_DEEP;
+		for (LeafOctree *octreenode = octree_owning_leaf[i]; octreenode && visit_parents>=0; octreenode=octreenode->parent, visit_parents--)
+		{
+			for (std::vector<int>::iterator it=octreenode->leaves.begin(); it!=octreenode->leaves.end(); it++)
 			{
-			//coplanaridad y lo invierto
-			coptmp2 = Hojasa[counth].Coplanaridad(Hojasa[j]); 
-			coptmp = 1 - coptmp2;
-			//distancia y la normalizo
-			//distmp2 = Hojasa[counth].Distancia(Hojasa[j]); 
-			distmp2 = Hausdorff(Hojasa[counth], Hojasa[j]); 
-			distmp = distmp2 / diametro;
-			// calculo el criterio para esa hoja
-			criteriotmp = (( K1 * distmp * distmp ) + (K2 * coptmp * distmp))/ (K1 + K2);
-			//selecciono el criterio menor
-			if (Hojasa[counth].criterio > criteriotmp) 
-			{
-				Hojasa[counth].criterio = criteriotmp;
-				Hojasa[counth].hoja_crit = j;}
-			}
-		}
-	}	
+				int j = *it;*/
+
+				if (j != countLeaves && Leaves[j].existe)
+				{
+					coptmp2 = Leaves[countLeaves].Coplanaridad(Leaves[j]); 
+					coptmp = 1 - coptmp2;
+					//distmp2 = HausdorffOptimized(Leaves[countLeaves], Leaves[j]);
+					distmp2 = DistanceFromCenters(Leaves[countLeaves], Leaves[j]);
+					distmp = distmp2 / diam;
+					
+					criteriatmp = (( K1 * distmp * distmp ) + (K2 * coptmp * distmp))/ (K1 + K2);
+					criteriatmp *= CalculateLeafArea(Leaves[j])/diam + area_leaf_i;
+					criteriatmp *= Leaves[j].Cuantas_hojas + Leaves[i].Cuantas_hojas;
+					
+					if (Leaves[countLeaves].criterio > criteriatmp) 
+					{
+						Leaves[countLeaves].criterio = criteriatmp;
+						Leaves[countLeaves].hoja_crit = j;
+					}
+				}
+	//		}
+		}
+//	}	
 
 	// Crear el paso de simplificación
 	Geometry::TreeSimplificationSequence::Step pasosimp;
-	pasosimp.mV0=Hojasa[cual].id_triangulo[0];
-	pasosimp.mV1=Hojasa[cual].id_triangulo[1];
-	pasosimp.mT0=Hojasa[otra].id_triangulo[0];
-	pasosimp.mT1=Hojasa[otra].id_triangulo[1];
+	pasosimp.mV0=Leaves[which].id_triangulo[0];
+	pasosimp.mV1=Leaves[which].id_triangulo[1];
+	pasosimp.mT0=Leaves[other].id_triangulo[0];
+	pasosimp.mT1=Leaves[other].id_triangulo[1];
 
 	// Nuevos vértices
-	pasosimp.mNewQuad[0]=Hojasa[counth].Vert_Hoja[0];
-	pasosimp.mNewQuad[1]=Hojasa[counth].Vert_Hoja[1];
-	pasosimp.mNewQuad[2]=Hojasa[counth].Vert_Hoja[2];
-	pasosimp.mNewQuad[3]=Hojasa[counth].Vert_Hoja[3];
+	pasosimp.mNewQuad[0]=Leaves[countLeaves].Vert_Hoja[0];
+	pasosimp.mNewQuad[1]=Leaves[countLeaves].Vert_Hoja[1];
+	pasosimp.mNewQuad[2]=Leaves[countLeaves].Vert_Hoja[2];
+	pasosimp.mNewQuad[3]=Leaves[countLeaves].Vert_Hoja[3];
 
 	// Insertar el paso de simplificación
